Bug 486403 - pcsc-lite cannot not initialise connection to hald
pcsc-lite cannot not initialise connection to hald
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: pcsc-lite (Show other bugs)
10
i386 Linux
low Severity medium
: ---
: ---
Assigned To: Bob Relyea
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-02-19 11:25 EST by David Mueller
Modified: 2010-01-06 15:10 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 02:58:27 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description David Mueller 2009-02-19 11:25:55 EST
Description of problem:
pcsc-lite terminates after starting when the system boots.  /var/log/boot.log reports that the daemon started ok, but /var/log/messages shows that it terminated:

/var/log/boot.log:
Starting PC/SC smart card daemon (pcscd): [  OK  ]

/var/log/messages:
Feb 19 08:04:54 mueller pcscd: pcscdaemon.c:498:main() pcsc-lite 1.4.102 daemon 
ready.
Feb 19 08:04:55 mueller pcscd: hotplug_libhal.c:485:HPRegisterForHotplugEvents()
 Could not initialise connection to hald.
Feb 19 08:04:55 mueller pcscd: hotplug_libhal.c:486:HPRegisterForHotplugEvents()
 Normally this means the HAL daemon (hald) is not running or not ready.
Feb 19 08:04:55 mueller pcscd: pcscdaemon.c:517:main() SVCServiceRunLoop returne
d
Feb 19 08:04:55 mueller pcscd: pcscdaemon.c:523:at_exit() cleaning /var/run

At this point the USB smart card reader doesn't work; nothing shows up in /var/log/messages when I insert a smart card.  If I restart the pcscd daemon, then things work fine:

# /etc/init.d/pcscd restart
Stopping PC/SC smart card daemon (pcscd):                  [FAILED]
Starting PC/SC smart card daemon (pcscd):                  [  OK  ]

Feb 19 08:20:24 mueller pcscd: pcscdaemon.c:498:main() pcsc-lite 1.4.102 daemon ready.
Feb 19 08:20:24 mueller pcscd: hotplug_libhal.c:342:HPAddDevice() Adding USB device: usb_device_4e6_e001_602015BB_if0
Feb 19 08:20:25 mueller pcscd: readerfactory.c:1082:RFInitializeReader() Attempting startup of SCM SCR 331 00 00 using /usr/lib/pcsc/drivers/ifd-ccid.bundle/Contents/Linux/libccid.so
Feb 19 08:20:25 mueller pcscd: readerfactory.c:949:RFBindFunctions() Loading IFD Handler 3.0
Feb 19 08:20:25 mueller pcscd: ifdhandler.c:1323:init_driver() Driver version: 1.3.8
Feb 19 08:20:25 mueller pcscd: ifdhandler.c:1336:init_driver() LogLevel: 0x0003
Feb 19 08:20:25 mueller pcscd: ifdhandler.c:1356:init_driver() DriverOptions: 0x0004
Feb 19 08:20:25 mueller pcscd: ifdhandler.c:81:IFDHCreateChannelByName() lun: 0, device: usb:04e6/e001:libhal:/org/freedesktop/Hal/devices/usb_device_4e6_e001_602015BB_if0
Feb 19 08:20:25 mueller pcscd: ccid_usb.c:236:OpenUSBByName() Manufacturer: Ludovic Rousseau (ludovic.rousseau@free.fr)
Feb 19 08:20:25 mueller pcscd: ccid_usb.c:246:OpenUSBByName() ProductString: Generic CCID driver
Feb 19 08:20:25 mueller pcscd: ccid_usb.c:252:OpenUSBByName() Copyright: This driver is protected by terms of the GNU Lesser General Public License version 2.1, or (at your option) any later version.
Feb 19 08:20:25 mueller pcscd: ccid_usb.c:408:OpenUSBByName() Found Vendor/Product: 04E6/E001 (SCM SCR 331)
Feb 19 08:20:25 mueller pcscd: ccid_usb.c:410:OpenUSBByName() Using USB bus/device: 002/007
Feb 19 08:20:25 mueller pcscd: ccid_usb.c:780:get_data_rates() IFD does not support GET_DATA_RATES request: Broken pipe
Feb 19 08:20:25 mueller pcscd: ifdhandler.c:307:IFDHGetCapabilities() lun: 0, tag: 0xFB0
Feb 19 08:20:25 mueller pcscd: readerfactory.c:267:RFAddReader() Using the pcscd polling thread
Feb 19 08:20:25 mueller pcscd: ifdhandler.c:307:IFDHGetCapabilities() lun: 0, tag: 0xFAE
Feb 19 08:20:25 mueller pcscd: ifdhandler.c:353:IFDHGetCapabilities() Reader supports 1 slot(s)

At this point things work properly; the reader recognizes the insertion of the smart card.

Version-Release number of selected component (if applicable):
pcsc-lite-1.4.102-3.fc10.i386

How reproducible:
Always

Steps to Reproduce:
1. Boot computer
2. Insert smart card
  
Actual results:
Nothing happens; no blinking light on card reader

Expected results:
Card reader recognized; light on card reader starts blinking
Comment 1 Bob Relyea 2009-02-24 19:11:52 EST
Do me a favor, try the following change:

in /etc/init.d/pcsc-lite change

> chkconfig: 2345 25 88

to

> chkconfig: 345 27 88

bob
Comment 2 Bob Relyea 2009-02-24 19:20:41 EST
you man have to stop pcscd and run the following command after you made the changes:

/sbin/chkconfig pcscd resetpriorities

then restart pcscd.


bob
Comment 3 David Mueller 2009-02-25 11:36:39 EST
Tried the change and rebooted, still didn't work.  The file name was actually /etc/init.d/pcscd.

Looking at the order of startup in /var/log/boot.log, it looks like pcsc-lite is starting before the HAL daemon.  Could this be a problem?

Also, I don't know if this would make a difference, but the system was a Fedora 8 system that was updated to Fedora 10 using the anaconda installer on the Fedora 10 DVD.
Comment 4 Bob Relyea 2009-02-26 20:50:31 EST
> Looking at the order of startup in /var/log/boot.log, it looks like pcsc-lite
> is starting before the HAL daemon.  Could this be a problem?

I'm presuming that this is the problem. On my fresh install of Fedora 10 everything is started up correctly (even without the change). There is an LSB header which includes the lines 'Should start: udev hal openct'

Even though the chkconfig line has 25, on my system the daemon is start at priority 26 (making it start after hal).

what do you get if you run:

ls *hal* *pcsc*

In each of these directories:

rc2.d rc3.d rc4.d and rc5.d ?

bob
Comment 5 David Mueller 2009-02-26 22:22:29 EST
(In reply to comment #4)

> what do you get if you run:
> 
> ls *hal* *pcsc*
> 
> In each of these directories:
> 
> rc2.d rc3.d rc4.d and rc5.d ?

# cd /etc/rc.d
# ls rc*/*hal*
rc0.d/K02haldaemon  rc1.d/K02haldaemon  rc3.d/S98haldaemon  rc5.d/S98haldaemon
rc0.d/S01halt       rc2.d/K02haldaemon  rc4.d/S98haldaemon  rc6.d/K02haldaemon
# ls rc*/*pcsc*
rc0.d/K74pcscd  rc2.d/S27pcscd  rc4.d/S27pcscd  rc6.d/K74pcscd
rc1.d/K74pcscd  rc3.d/S27pcscd  rc5.d/S27pcscd

Which makes the problem pretty obvious to me.  Taking a hint from your previous post in comment #2, I then ran

/sbin/chkconfig haldaemon resetpriorities

and rebooted and things work properly.

# ls rc*/*hal*
rc0.d/K02haldaemon  rc1.d/K02haldaemon  rc3.d/S26haldaemon  rc5.d/S26haldaemon
rc0.d/S01halt       rc2.d/K74haldaemon  rc4.d/S26haldaemon  rc6.d/K02haldaemon

So it looks like this might have been a problem with Anaconda's update; the priority changed between Fedora releases and resetpriorities wasn't run.
Comment 6 Jacek Piskozub 2009-05-28 11:09:52 EDT
I had the same problem with yum update so Anaconda is most probably innocent (or at least not the only guilty party).
Comment 7 Bug Zapper 2009-11-18 06:09:51 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Bug Zapper 2009-12-18 02:58:27 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 9 Joel 2010-01-06 15:10:28 EST
Please reopen.  Still a problem with FC12 as of today's updates.  

I have to do a service pcscd start even though the service is already running.  Checking the logs, pcscd looks to be starting before hotplug_libhal.c can connect to HAL service.

Note You need to log in before you can comment on or make changes to this bug.